<?
 require_once($_path["include"]."data.php");
 require_once($_path["include"]."template.php");
 require_once($_path["plugins"]."lister/lister.php");

 class navigation extends lister
 {
  function _getData()
  {
   global $_benchmark;

   if(!isset($this->config)||!$this->config)
    return false;

   if($_benchmark) $_benchmark->start("Data object");

   $d=Data::cache("pager_categories", "tree", "down");
   $d->clearValues();

   //set show fields so lister->cache takes these in to account when checking cache
   $d->setValue("catnr", $this->config["listcatnr"]);

   if($this->config["treedepth"])
    $d->setValue("treedepth", $this->config["treedepth"]-1);

   $d->sortOrder("ordernr", "name");

   if($_benchmark) $_benchmark->stop("Data object");

   return $d;
  }


  function output()
  {
   global $_path, $_config, $_benchmark;

   if($_benchmark) $_benchmark->start("Get content");

   if(!($d=$this->_getData()))
    return $this->e->show();

   $id=$d->getID();

   if($_config["useModRewrite"]) //mod rewrite
   {
    $d->addField("base_url", "text", "", "control", 0, false, $_path["HTML"]["current"]);

    $tmp=$_path["HTML"]["current"];
    foreach($this->plugin->vars as $k => $v)
     if($k=="p"||substr($k, 0, 2)=="p[")
      $tmp.=$v."/";

    $d->addField("page_url", "text", "", "control", 0, false, $tmp);

    unset($tmp);
   }
   else
    $d->addField("base_url", "text", "", "control", 0, false, "");

   $d->addField("level", "nr", "", "", 0, false, 1);

   //load template
   if($this->config["templatelist"])
    $templateFile=$_path["project"]["templates"].$this->config["templatelist"];
   else
    $templateFile=$this->plugin->path["templates"].$this->plugin->templatelist;

   if($_benchmark) $_benchmark->start("Template");

   $template=new Template($templateFile, true);

   if(!$template->analyze($d))
   {
    $this->e->add($template->e);
    return false;
   }

   if($template->markerExists("_fields")&&$this->config["showfields"]) //_fields marker in template and predefined fields set
    $d->setShowFields(array_merge($this->config["showfields"], $d->check("use", "show"))); //added predefined fields to show fields
   //else //use template defined fields

   if($_benchmark) $_benchmark->stop("Template");

   if($_benchmark) $_benchmark->start("Get data");

   //get data
   if(!$d->get($template->getLevel()))
   {
    $this->e->add($d->e);
    return false;
   }

   //set base_url values
   for($c=0;$c<$d->vmax;$c++)
   {
    $d->setDefaultValue("base_url", $c);
    $d->setValue("level", $d->getValue("treedepth", $c)+2, $c);
   }

   if($_benchmark) $_benchmark->stop("Get data");
   if($_benchmark) $_benchmark->start("Populate template");

   if(!$template->populate())
   {
    $this->e->add($template->e);
    return false;
   }

   $output=$template->output();

   if($_benchmark) $_benchmark->stop("Populate template");

   if($_benchmark) $_benchmark->stop("Get content");

   return $output;
  }

 }
?>
